	cpu	6800
	* = $1000

MAXX	equ	4

; Kill key beep just in case

	clra		; System variable
	stab	$0

	sei

	ldaa	#$01
	eora	$C803
	staa	$C803
	oraa	#$03
	anda	#$3F
	staa    $C803

	cli

; Clear to black
	clra
	ldab	#0
	ldx	#$c500
klr	staa	,x
	inx
	staa	,x
	inx
	staa	,x
	inx
	decb
	bne	klr

; Two rows of red fg attribute we must catch
	ldaa	#2
	ldab	#64
	ldx	#$c500+32*21

reddi	staa	,x
	inx
	decb
	bne	reddi

; Set fast timer interrupt for searching the red rows
	ldab	#0
	stab	$c817
	ldab	#8
	stab	$c818

	ldx	#search
	sei
	stx	$104
	cli

; Wait until vbi found
goon	ldaa	found
	beq	goon
	bra	animst

; Search interrupt hook
search	ldaa	$ca00 ; First wait for two red attributes
	nop
	cmpa	#2
	bne	skippa

	ldaa	$ca00
	nop
	cmpa	#2
	bne	skippa

	ldaa	$ca00 ; Finally one black attribute
	bne	skippa

	ldab	#0 ; Next interrupt a bit further
	stab	$c817
	ldab	#190
	stab	$c818

	ldx	#handu
	sei
	stx	$10c
	ldx	#0
	stx	$104
	cli
	ldaa	#1
	staa	found

skippa	staa	$ca00
	jmp	$e7e7 ; Jump to system IRQ handler

; The actual VBI handler (user timer hook)
handu	ldaa	adjust
	deca
	beq	yesadj

	ldab	#13	; Slower timer for three frames
	stab	$c817
	ldab	#86
	stab	$c818
	bra	done

yesadj	ldab	#13	; Faster for one frame to keep the sync
	stab	$c817
	ldab	#85
	stab	$c818
	ldaa	#MAXX

done	staa	adjust

	inc	vbicnt
	jsr	playa
	rts

; Wait a while until animation starts
animst	clra
	staa	$ca00
	ldab	#3*50
moree	jsr	waitvb
	decb
	bne	moree

; Screen to blue
	ldaa	#1
	staa	$ca00

	ldx	#$c100
	ldaa	#9
	ldab	#768/4

klr1	staa	,x
	inx
	staa	,x
	inx
	staa	,x
	inx
	staa	,x
	inx
	decb
	bne	klr1

	ldx	#$c500
	ldaa	#$89
	ldab	#768/4

klr2	staa	,x
	inx
	staa	,x
	inx
	staa	,x
	inx
	staa	,x
	inx
	decb
	bne	klr2

; First frame is different
	bsr	waitvb
	ldx	#frame0
	jsr	draw

; Main loop
main	bsr	waitvb
	bsr	waitvb
	bsr	waitvb

	ldx	curr
	ldx	,x
	jsr	draw

	ldx	curr
	inx
	inx
	stx	curr
	ldx	,x
	beq	wrap
	bra	main

wrap	ldx	#frames
	stx	curr
	bra	main

; Draw frame as diff to previous
draw	sts	temppi
	sei
	ldab	,x
	inx

diff	lds	,x
	inx
	inx
	ldaa	,x
	inx
	psha

	lds	,x
	inx
	inx
	ldaa	,x
	inx
	psha

	decb
	bne	diff
	lds	temppi

	cli
	rts

; Wait until VBI
waitvb	ldaa	vbicnt
ventta	cmpa	vbicnt
	beq	ventta
	rts

frames	dw	frame1,frame2,frame3,frame4,frame5,frame6,frame7
	dw	frame8,frame9,frame10,frame11,frame12,0
curr	dw	frames
temppi	dw	0

vbicnt	db	0
adjust	db	MAXX
found	db	0

; *** The music player starts here ***
playa	dec	count
	beq	newrow
	jmp	norow

; A new row! Need to do several things
newrow	inc	row
	ldaa	row
	cmpa	#64
	bne	nopatt

; A new pattern! Gosh!
	clra
	staa	row
	ldx	pos
	inx
	inx
	stx	pos
	ldx	,x
	bne	loadptr

; Need to jump to the repeat point
	ldx	repeat
	stx	pos
	ldx	,x

loadptr	stx	rowptr
	bra	notes

nopatt	ldx	rowptr ; Next row
	inx
	inx
	inx
	inx
	inx
	inx
	inx
	inx
	inx
	stx	rowptr

; Handle new notes and once-per-row commands
; 1st channel
notes	ldx	rowptr
	ldaa	,x
	beq	nonote1
	staa	note1
	staa	base1

nonote1	ldaa	1,x
	beq	arp1
	cmpa	#$c
	beq	vol1
	cmpa	#$f
	beq	spd1
	cmpa	#$1d
	beq	trm1
	bra	chn2

trm1	ldaa	base1
	staa	note1
	bra	chn2

vol1	clra
	staa	note1
	bra	chn2

spd1	ldab	2,x
	stab	speed
	bra	chn2

arp1	ldab	2,x
	beq	chn2
	ldaa	base1
	staa	note1

; 2nd channel
chn2	ldaa	3,x
	beq	nonote2
	staa	note2
	staa	base2

nonote2	ldaa	4,x
	beq	arp2
	cmpa	#$c
	beq	vol2
	cmpa	#$f
	beq	spd2
	cmpa	#$1d
	beq	trm2
	bra	chn3

trm2	ldaa	base2
	staa	note2
	bra	chn3

vol2	clra
	staa	note2
	bra	chn3

spd2	ldab	5,x
	stab	speed
	bra	chn3

arp2	ldab	5,x
	beq	chn3
	ldaa	base2
	staa	note2

; 3rd channel
chn3	ldaa	6,x
	beq	nonote3
	staa	note3
	staa	base3

nonote3	ldaa	7,x
	beq	arp3
	cmpa	#$c
	beq	vol3
	cmpa	#$f
	beq	spd3
	cmpa	#$1d
	beq	trm3
	bra	rowdone

trm3	ldaa	base3
	staa	note3
	bra	rowdone

vol3	clra
	staa	note3
	bra	rowdone

spd3	ldab	8,x
	stab	speed
	bra	rowdone

arp3	ldab	8,x
	beq	rowdone
	ldaa	base3
	staa	note3

rowdone	ldaa	speed	; Reset tick counter
	staa	count

	clra		; Clear arpeggio and termor pos
	staa	arpc1
	staa	arpc2
	staa	arpc3

	staa	trmc1
	staa	trmc2
	staa	trmc3

	bra	getout

; No new row this time, just check the necessary commands
norow	ldx	rowptr

; 1st channel fx (just arpeggio and tremor for now)
fx1	ldaa	1,x
	cmpa	#$1d
	beq	trem1
	cmpa	#0
	bne	fx2
	ldaa	2,x
	beq	fx2
	ldx	#arpc1
	bsr	arppi
	bra	fx2

trem1	ldaa	2,x
	ldx	#trmc1
	bsr	tremmi

fx2	ldaa	4,x
	cmpa	#$1d
	beq	trem2
	cmpa	#0
	bne	fx3
	ldaa	5,x
	beq	fx3
	ldx	#arpc2
	bsr	arppi
	bra	fx3

trem2	ldaa	5,x
	ldx	#trmc2
	bsr	tremmi

fx3	ldaa	7,x
	cmpa	#$1d
	beq	trem3
	cmpa	#0
	bne	getout
	ldaa	8,x
	beq	getout
	ldx	#arpc3
	bsr	arppi
	bra	getout

trem3	ldaa	8,x
	ldx	#trmc3
	bsr	tremmi

getout	bsr	setfreq
	rts

; Take care of the arpeggio notes (X=counter address, A=param)
arppi	inc	,x
	ldab	,x
	cmpb	#1
	beq	param1
	cmpb	#2
	beq	param2

	clrb ; Bare note, copy base to current
	stab	,x
	ldaa	3,x
	staa	6,x
	rts

param1	lsra ; High 4 bits = plus to base
	lsra
	lsra
	lsra
	adda	3,x
	staa	6,x
	rts

param2	anda	#15 ; Low bits = plus to base
	adda	3,x
	staa	6,x
	rts

; Take care of the tremor buzz (X=counter address, A=param)
tremmi	inc	,x
	tab
	lsrb
	lsrb
	lsrb
	lsrb
	cmpb	,x	; Note still on
	bpl	trdone

	anda	#15
	aba
	clrb		; Silence
	stab	9,x

	cmpa	,x	; Wrap the counter
	bpl	trout

	ldaa	#-1
	staa	,x
	rts

trdone	ldaa	6,x
	staa	9,x
trout	rts

; Routine to set the freqs of all channels
setfreq	ldaa	note1 ; Channel 1
	beq	silent1

	cmpa	prev1 ; Don't retrig
	beq	freq2
	staa	prev1

	asla
	staa	tmp+1
	ldx	tmp
	ldaa	,x
	staa	$c81a
	ldaa	1,x
	staa	$c81b
	ldaa	#$e
	staa	$c819
	bra	freq2

silent1	clra
	staa	$c819
	staa	prev1

freq2	ldaa	note2 ; Don't retrig, channel 2
	cmpa	prev2
	beq	freq3
	staa	prev2

	asla
	staa	tmp2+1
	ldx	tmp2
	ldaa	,x
	staa	$c813
	ldaa	1,x
	staa	$c812

freq3	ldaa	note3 ; Don't retrig, channel 3
	cmpa	prev3
	beq	frdone
	staa	prev3

	asla
	staa	tmp2+1
	ldx	tmp2
	ldaa	,x
	staa	$c815
	ldaa	1,x
	staa	$c814

frdone	rts

row	db	63
rowptr	dw	0
count	db	1
speed	db	6
pos	dw	order-2

tmp	dw	frequs ; For indexing the 256-aligned arrays
tmp2	dw	frequs2

trmc1	db	0 ; Tremor counters
trmc2	db	0
trmc3	db	0

arpc1	db	0 ; Arpeggio counters
arpc2	db	0
arpc3	db	0

base1	db	0 ; Base note for arpeggios
base2	db	0
base3	db	0

note1	db	0 ; Current note
note2	db	0
note3	db	0

prev1	db	0 ; Previous played note so that we don't retrig all the time
prev2	db	0
prev3	db	0

	include anim.inc
	include nyantune.inc
	include frequs.inc
